﻿Imports System.Windows.Forms
Imports ESRI.ArcGIS.Controls
Imports ESRI.ArcGIS.Display
Imports ESRI.ArcGIS.Carto

Public Class SymbolForm

	Private WithEvents AxSymbolControl1 As ESRI.ArcGIS.Controls.AxSymbologyControl
	Public MarkerSymbol As IMarkerSymbol

	Private Sub SymbolForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		' Create symbol control
		Dim SymControl As New ESRI.ArcGIS.Controls.AxSymbologyControl
		Dim Init As System.ComponentModel.ISupportInitialize = SymControl
		Init.BeginInit()
		SymControl.Location = pbSymbol.Location
		SymControl.Size = pbSymbol.Size
		SymControl.Name = "SymControl"
		Me.Controls.Add(SymControl)
		Init.EndInit()
		SymControl.BringToFront()
		AxSymbolControl1 = SymControl
		pbSymbol.Visible = False
		btnSelect.Enabled = False
	End Sub

	Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
		' Load a style file (only ServerStyle will work in ArcReader)
		Dim ofd As New OpenFileDialog
		ofd.Filter = "Style files (*.ServerStyle)|*.ServerStyle"
		ofd.Title = "Load Style File"
		If ofd.ShowDialog() <> DialogResult.OK Then
			Exit Sub
		End If
		Try
			Dim sFile As String = ofd.FileName
			AxSymbolControl1.StyleClass = esriSymbologyStyleClass.esriStyleClassMarkerSymbols
			AxSymbolControl1.LoadStyleFile(sFile)
		Catch ex As Exception
			MsgBox("Could not open style file.")
		End Try
	End Sub

	Private Sub btnSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelect.Click
		Try
			Dim pColor As IRgbColor = Me.MarkerSymbol.Color
			pColor.Red = CByte(tbRed.Text)
			pColor.Green = CByte(tbGreen.Text)
			pColor.Blue = CByte(tbBlue.Text)
			Me.MarkerSymbol.Color = pColor
			Me.DialogResult = DialogResult.OK
		Catch ex As Exception
			MsgBox("Assigning color.")
		End Try
	End Sub

	Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
		Me.MarkerSymbol = Nothing
		Me.DialogResult = Windows.Forms.DialogResult.OK
	End Sub

	Private Sub SymbolSelected(ByVal sender As Object, ByVal StyleGalleryItem As Object) Handles AxSymbolControl1.OnItemSelected
		btnSelect.Enabled = True
		Try
			Dim gItem As IStyleGalleryItem
			gItem = AxSymbolControl1.GetStyleClass(AxSymbolControl1.StyleClass).GetSelectedItem()
			If Not TypeOf gItem.Item Is IMarkerSymbol Then
				MsgBox("Not a marker symbol.") ' This should never happen
				Exit Sub
			End If
			Me.MarkerSymbol = gItem.Item
			Dim pColor As IRgbColor = Me.MarkerSymbol.Color
			tbRed.Text = pColor.Red.ToString()
			tbGreen.Text = pColor.Green.ToString()
			tbBlue.Text = pColor.Blue.ToString()
		Catch ex As Exception
			MsgBox("Error selecting symbol.")
		End Try

	End Sub

End Class